
(* "type foo = ('a, 'b) bar" -> ("foo", ["a", "b"] {bar}) *)
type type_def = string * (string list) * type_info
and  type_def_list = type_def list
and  type_info = type_rep
and  type_rep  = OUnion of constr_decl list 
                | ORecord of field_decl list
                | OType of typexpr 
and constr_decl = string       (* name *) 
                 * (typexpr option) 
and field_decl  = bool         (* mutable? *)
                 * string       (* name *) 
                 * polytypexpr 
and polytypexpr = typexpr
and typexpr     = 
  | Tick of string        (* 'a *)
  | Underscore            (* _ *) 
  (* ( otypexpr ) *) 
  | FunType of typexpr * typexpr (* a -> b *)
  | Tuple of typexpr list (* a * b * c * d *)
  | Constructor of string * typexpr list  (* (a,b) list *)
