type 'a intpair = 'a * int
and intintpair = int intpair
and stringintpair = string intpair

let rec sum_intpair (f : unit -> 'a -> int) () (arg : 'a intpair) =
  let (x,y) = arg in
  (f () x) + y
and sum_intintpair () (arg : intintpair) = 
  sum_intpair (fun () i -> i) () arg 
and sum_stringintpair () (arg : stringintpair) =
  sum_intpair (fun () s -> int_of_string s) () arg
;; 

let x = (1,2) in
let y = ("1",2) in
Printf.printf "%d %d\n"
  (sum_intintpair () x) (sum_stringintpair () y) ;;
